> For the complete documentation index, see [llms.txt](https://docs.tonic.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/valid-address-validaddressgenerator.md).

# Valid Address (ValidAddressGenerator)

The [Valid Address](/app/generation/generators/generator-reference/valid-address.md) generator replaces the source value with a real address value from the United States, Brazil, or Mexico.

## Link object structure

The Valid Address generator can be self-consistent or consistent with another column. You cannot configure differential privacy. It can be linked to other columns.

The metadata object is populated from `ValidAddressMetadata`.

For the Valid Address generator, you select the country to use. You can either identify a specific country, or identify a column that contains the country. If the column does not contain a valid country value, then Structural uses the fallback generator.

For linked columns, Structural uses the same country for all of the columns.

After you configure the country, you specify the type of address value that is in the source column.

Here is the basic structure of a link object for the Valid Address generator.

{% code overflow="wrap" %}

```json
{
  "schema": "string",
  "table": "string",
  "column": "street",
  "metadata": {
    "presetId": "string",
    "generatorId": "ValidAddressGenerator",
    "country": "string", // Do not set if countryColumn is set.
    "countryColumn": "string", // Do not set if country is set.
    "addressComponent": "StreetAddress",
    "isConsistent": boolean,
    "consistencyColumn": "string",
    "caseSensitiveConsistency": boolean
  }
}
```

{% endcode %}

## Example replacement

The following example shows linked columns that are assigned the built-in generator preset for the Valid Address generator.

The request specifically sets the country to be the United States.

One column contains city names, and the other postal codes. Self-consistency is enabled and consistency is case-sensitive.

{% code overflow="wrap" %}

```json
{
  "name": "city,postal_code",
  "schema": "public",
​  "table": "locations",
​  "links": [
​    {
​      "column": "city",
      "table": "locations",
​      "schema": "public",
​        "metadata": {
​        "presetId": "ValidAddressGenerator",
​        "generatorId": "ValidAddressGenerator",
        "country": "UnitedStates",
​        "addressComponent": "City",
​        "isConsistent": true,
        "caseSensitiveConsistency": true
​      }
    },
​    {
      ​"column": "postal_code",
​      "table": "locations",
​      "schema": "public",
​      "metadata": {
​        "presetId": "ValidAddressGenerator",
​        "generatorId": "ValidAddressGenerator",
        "country": "UnitedStates",
​        "addressComponent": "PostalCode",
​        "isConsistent": true,
        "caseSensitiveConsistency": true
​      }
​    }
​  ]
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/valid-address-validaddressgenerator.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
